#include "typedef.h"

/* (c) Copyright 1989 by Jotun Hein.  This program can be copied as long as
   this message is not deleted and it is distributed free of charge */

/* parnni.c rearranges preliminary tree in order to obtain more parsimoneous 
tree nd it let tdistree.c do the merging */

extern int bladcount[5],globali();
extern float afstand();
extern FILE *pout,*pin,*pphyl;

extern struct inpar parr;
extern struct globa globs;
extern struct treep t;

struct node *trees(),auxtree;
int newwei,config();
float dis_sure();

/* improve continues to subject the phyl2ogeny to cycles of nni as long as improvements are obtained */

improvepar()
{assigndive(t.top);
 t.cyclno=1;newwei=globs.totdist=t.top->wei;
 treeinit(t.top);
/* if (t.parcycmax) iev(1);
 while (t.parcycmax>t.cyclno && globs.totdist>newwei){
   t.cyclno++;treeinit(t.top);globs.totdist=newwei;iev(1);
   if (parr.screen) printf("finished cycle %d of improvements\n",t.cyclno);
  }
*/
/* After swithcing to dyn.allo. sq.gr.s I have switched nni on parsimony tree
off.  It should be reintroduced, probably with having all the sq.gr allo. 
individually */

 globs.totdist=t.top->wei;
}


/* maketop finally combines the four parsimony subtrees */

maketop()
{iniback(t.top->left);
 iniback(t.top->right);
 iniback(t.top);
}

/* n is pointer to the node whose ancestral sequence is to be used.  If s==1 
   then swapping is allowed,  otherwise not  */

iniback(n)
struct node *n;
{
 n->wei=n->left->wei+n->right->wei+
          globali(n->left->sqno,n->right->sqno,n->sqno);
 n->up=0;
 n->tip=0;
}


/* swapit checks the three configurations and rearranges towards the cheapest */

swapit()
{int treewei[3],m;
 treewei[0]=newwei;
 treewei[1]=config(1);
 treewei[2]=config(2);
 m=min3(treewei[0],treewei[1],treewei[2]);
  if (parr.screen==2) 
   printf("configurations %d  %d  %d \n",treewei[0],treewei[1],treewei[2]);
 if (m==newwei){}
  else if (m==treewei[1]){
  if (parr.screen==1) 
   printf("configurations %d  %d  %d \n",treewei[0],treewei[1],treewei[2]);
  auxtree=(*t.top->left->right);
  fprintf(pout,"now par-swapping  1\n"); 
  *t.top->left->right=(*t.top->right->right);
  *t.top->right->right=auxtree;
  clean4(t.top->sqno);
  clean4(t.top->left->sqno);
  clean4(t.top->right->sqno);
  maketop();
}
 
 else if (m==treewei[2]){
  if (parr.screen==1) 
   printf("configurations %d  %d  %d \n",treewei[0],treewei[1],treewei[2]);
  auxtree=(*t.top->left->right);
  fprintf(pout,"now par-swapping  2\n"); 
  *t.top->left->right=(*t.top->right->left);
  *t.top->right->left=auxtree;
  clean4(t.top->sqno);
  clean4(t.top->left->sqno);
  clean4(t.top->right->sqno);
  maketop();
 fprintf(pphyl,"\n\n");
}

   t.top->left->done=(t.top->left->left->done && t.top->left->left->edge &&
		    t.top->left->right->done && t.top->left->right->edge);

   t.top->right->done=(t.top->right->left->done && t.top->right->left->edge &&
		    t.top->right->right->done && t.top->right->right->edge);

 newwei=m;
 t.top->left->edge=t.top->right->edge=1;
}

/* config evaluates the weight of the top of the tree if it has configuration
   (t1,t2)(t3,t4) */

int
config(ty)
int ty;
{int i,m,m1,m2,m0;
 m=t.top->left->left->wei+t.top->left->right->wei+t.top->right->left->wei+
   t.top->right->right->wei;

/* REMEMBER THAT THIS PROCEDURE MUST BE REWRITTEN TO USE INIBACK why? */

 if (ty==1){
  m1=globali(t.top->left->left->sqno,t.top->right->right->sqno,globs.totno-4);

  m2=globali(t.top->left->right->sqno,t.top->right->left->sqno,globs.totno-5);
 }

 if (ty==2){
  m1=globali(t.top->left->left->sqno,t.top->right->left->sqno,globs.totno-4);

 }
 
  m0=globali(globs.totno-4,globs.totno-5,0);

for(i=4;i<=5;i++) clean4(globs.totno-i);
return(m+m1+m2+m0);
}

float dis_sure()
{float res=0.0;
 int i;
 for (i=1;i<=4;i++) if (trees(i)->dislen>res) res=trees(i)->dislen;

 if (t.top->left->dislen) res=t.top->left->dislen;

 return(res);
}


ready(ty)
int ty;
{int i,j=0;
 float r;
 r=dis_sure(); 
 if (ty)
 if (r>((float)globs.lave*t.inhibit)){
  for (i=1;i<5;i++)
   trees(i)->edge=1;
   t.top->left->edge=t.top->right->edge=1;
   t.top->left->done=(t.top->left->left->done && t.top->left->right->done); 
   t.top->right->done=(t.top->right->left->done && t.top->right->right->done); 
 fprintf(pout,"swapprohibition %f  %f\n",r,(float)globs.lave*t.inhibit);
 }
 for (i=1;i<5;i++)
  if (trees(i)->done && trees(i)->edge) j++; 
 return((j>1) && !t.top->left->edge); 
}


/* treeinit traverses the four staarting initial par. trees and labels visedge,    updir etc appropriately */


treeinit(p)
struct node *p;
{if (!p->tip){
  treeinit(p->left);
  treeinit(p->right);
  p->done=(p->left->tip && p->right->tip);
  p->edge=0;
 }
 else{
  p->done=1;
  p->edge=100;
 }
} 

iev(t)
int t;
{
 if (t) {if (ready(t)) swapit();} 
 else   {if (ready(t)) disswapit();}
 goon(t);
}

struct node *
trees(ty)
int ty;
{struct node *p;
 if (ty==1) p=t.top->left->left;
 if (ty==2) p=t.top->left->right;
 if (ty==3) p=t.top->right->left;
 if (ty==4) p=t.top->right->right;
 return(p);
}

/* assigndive dives down a rooted bifurcating tree and assigns sequence
   graphs to internal nodes */

assigndive(pn)
struct node *pn;
{if (!pn->tip){
  assigndive(pn->left); 
  assigndive(pn->right); 
  iniback(pn);
}
 else {pn->wei=0;
       pn->up=0;}
} 
